-- Written by Ashnal, with some play test help from Pippu
-- Replacement for SPB Lock. Load after Acrobatics, turn SPB lock off with "ac_spblock off"
-- Changes the speed of the trick meter, change these values from 0 to whatever you want to turn it on

if au_acrometeradjust == nil then rawset (_G, "au_acrometeradjust", true) else return end 

if au_acrometer == nil then rawset (_G, "au_acrometer", true) else return end 

local cv_spblock = CV_FindVar("ac_SPBlock")

local cv_adjust = CV_RegisterVar({
    name = "au_ac_adjust",
    defaultvalue = "Off",
    flags = CV_NETVAR, -- Doesnt really matter, but this will let clients know its on
    PossibleValue = CV_OnOff
})

-- Adds always active adjustment, can use negative values if you want
local cv_gain = CV_RegisterVar({
    name = "au_ac_extragain",
    defaultvalue = "0",
    flags = CV_NETVAR,
    PossibleValue = {MIN = -9, MAX = 400}
})

-- Adds always active adjustment
local cv_loss = CV_RegisterVar({
    name = "au_ac_extraloss",
    defaultvalue = "0",
    flags = CV_NETVAR,
    PossibleValue = {MIN = -4, MAX = 400}
})

-- Adds spb run only adjustment
local cv_spbgain = CV_RegisterVar({
    name = "au_ac_extraspbgain",
    defaultvalue = "15",
    flags = CV_NETVAR,
    PossibleValue = {MIN = -9, MAX = 400}
})

local cv_spbloss = CV_RegisterVar({
    name = "au_ac_extraspbloss",
    defaultvalue = "10",
    flags = CV_NETVAR,
    PossibleValue = {MIN = -4, MAX = 400}
})

addHook("ThinkFrame", do
	if not cv_adjust.value then return end
	for p in players.iterate do
		if p.trickactive then
			if p.cmd.buttons & p.trick_button then
				p.trickcharge = min($ + cv_gain.value, 400)
				if p.trickdifficultyup then
					p.trickcharge = min($ + cv_spbgain.value, 400)
				end
			else
				p.trickcharge = max($ - cv_loss.value, 0)
				if p.trickdifficultyup then
					p.trickcharge = max($ - cv_spbloss.value, 0)
				end
			end
		end
	end
end)

-- If SPB lock is off, acro doesn't detect spbs for us. So we have to set it ourselves here
addHook("MobjThinker", function(actor)
	if not cv_adjust.value then return end
	if actor.extravalue1 == 1 
		if actor.tracer and actor.tracer.player then
			actor.tracer.player.trickdifficultyup = true 
		end
	else
		for p in players.iterate do
			p.trickdifficultyup = false
		end
	end
end, MT_SPB)

local function removeDifficulty(...)
	for p in players.iterate do
		p.trickdifficultyup = false
	end
end

addHook("PlayerSpawn", function(p)
	p.trickdifficultyup = false
end)

addHook("MobjRemoved", removeDifficulty, MT_SPB)