-- By Ashnal
-- You know how many scripts do the wierd "local k_speedboost = k_speedboost" thing?
-- Some other more dynamic globals that many mods rely on for per tic calcs also go through that super long string lookup in hardcode (lib_getenum)
-- Here, I've put all the ones that reasonably do not change during a race into a MapChange hook, so they can be put into
-- the Lua global registry where their lookups will be faster during gameplay

-- This script is why we reccommend loading this addon first

if au_globalizeharder == nil then rawset(_G, "au_globalizeharder", true) else return end

local function restartlevel(p, ...)
	COM_BufAddText(server, "map "..G_BuildMapName(gamemap))
end
COM_AddCommand("restartlevel", restartlevel, 1)

-- Don't turn this on unless you've loaded the addon as the very first addon of your load order, it defaults off since it could desync shit otherwise
local localleveltime = leveltime
local optimizeleveltime = 0
local cv_leveltimeoptimize = CV_RegisterVar({
    name = "au_leveltimeoptimize",
    defaultvalue = "Off",
    flags = CV_NETVAR|CV_CALL,
    PossibleValue = CV_OnOff,
	func = function(var)
		if not optimizeleveltime and var.value then
			print("This setting cannot be turned off. Restart the game to do so.")
			optimizeleveltime = 1
			localleveltime = leveltime
		elseif optimizeleveltime and not var.value then -- Optimize is already on and can't be turned off
			print("This setting cannot be turned off. Restart the game to do so.")
			COM_BufInsertText(server, "au_leveltimeoptimize on")
		end
	end
})


-- Tyron: That's fuckin illegal

local localmapnum = gamemap

addHook("MapChange", function(mapnum)
	localmapnum = mapnum
	rawset(_G,"gamemap", localmapnum)
	rawset(_G,"server", players[0]) -- actually, the server player is always player slot 0, so no need to use the laggy enum
	rawset(_G,"mapobjectscale", (mapheaderinfo[gamemap] and mapheaderinfo[gamemap].mobj_scale)) -- Use in any sort of physics and movement code usually, high impact
	rawset(_G,"gamespeed", CV_FindVar("kartspeed").value)
	localleveltime = -2
	if optimizeleveltime then
		rawset(_G,"leveltime", 0) -- We set 0 here but leave localleveltime at -2
	end
end)

addHook("NetVars", function(net)
	localleveltime = net($)
	localmapnum = net($)
	if optimizeleveltime then
		rawset(_G,"leveltime", max(0, localleveltime)) -- In case someone joins during the prethinkframes where it is negative
	end
	-- need to do these here since joiners don't run MapLoad/MapChange -- Holy shit I just realized you can substitute a NetVars hook for Mapload/MapChange specifically for joiners ...
	rawset(_G,"mapobjectscale", (mapheaderinfo[gamemap] and mapheaderinfo[gamemap].mobj_scale))
	rawset(_G,"gamespeed", CV_FindVar("kartspeed").value)
	rawset(_G,"server", players[0])
	rawset(_G,"gamemap", localmapnum)
end)

-- Even more illegal
local function rawsetleveltime(mo)
	if localleveltime > leveltime then -- ensures this only gets done once per frame, despite executing in a mobjthinker
		rawset(_G,"leveltime", localleveltime) -- Only gonna do this for leveltime since its easy to know what it should be when we cant actually retrieve the value since we overwrote it
		-- Also this could potentially be a little stinky since mods loaded before us might read the leveltime as one tic behind mods that load after us, whic is why we have this non-default
	end
end

addHook("ThinkFrame", do
	localleveltime = $ + 1 -- Here we increment since ThinkFrame executes after all MobjThinkers
	if optimizeleveltime == 1 then -- Optimize, add a condition here to check once per tic vs checking if it is on for each player
		addHook("MobjThinker", rawsetleveltime, MT_PLAYER) -- Can't be turned off anyways, so might as well use a conditional hook add
		optimizeleveltime = 2 -- Please don't add a hook every tic. It would eventually crash the game if you do it :P
	end
end)