-- By Ashnal
-- Rotates maps periodically whenever the server is empty

if au_maprotate == nil then rawset (_G, "au_maprotate", true) else return end 

local cv_maprotate = CV_RegisterVar({
    name = "au_maprotate",
    defaultvalue = "On",
    flags = CV_NETVAR, -- Doesnt really matter, but this will let clients know its on
    PossibleValue = CV_OnOff
})

local VOTE = 3

local count
local function ActivePlayers()
	count = 0
	for p in players.iterate do
		if p.spectator then continue end
		count = $ + 1
	end
	return count
end

local active, lastactive
addHook("ThinkFrame", do
	if not cv_maprotate.value then return end
	active = ActivePlayers()
	if leveltime > 31500 and not active then -- If you've been in a map longer than 15 minutes and no players
		if CV_FindVar("advancemap").value == VOTE then -- If set to vote and there are no players, exitlevel will just go to nextmap instead of random when exitlevel is called, so we fix that here
			COM_BufAddText(server, "map "..G_BuildMapName(0)) -- Randommap trick from hostmod
		else
			COM_BufInsertText(server, "exitlevel")
		end
	elseif not lastactive and active and leveltime > 0 and CV_FindVar("spbatk") and CV_FindVar("spbatk").value == 0 then -- This restarts a level when a player first enters
		G_ExitLevel(gamemap, true) -- Restarts the level
	end
	lastactive = active
end)