-- By Ashnal
-- Adds some extra commands useful for spectating

if not au_spectate then rawset(_G, "au_spectate", true) else return end

local PF_TIMEOVER = PF_TIMEOVER
local KITEM_KITCHENSINK = KITEM_KITCHENSINK
local k_itemtype = k_itemtype

local au_randomnum = {}

--blame freeman for this feature
--When on, will autospectate whomever rolls a sink
local cv_sinkspectate = CV_RegisterVar({
    name = "au_spectate_sink",
    defaultvalue = "On",
    flags = NULL,
    PossibleValue = CV_OnOff
})

local function Rescale(value, oldmin, oldmax, newmin, newmax)
	return newmin +  FixedMul(FixedDiv( value-oldmin , oldmax-oldmin), newmax-newmin)
end

local i, out
local function getActivePlayerIdArray(pexclude) -- Solves the sparse player id problem, allowing for picking of a random player from a contiguous array
	i = 1
	out = {}
	for p in players.iterate do
		if not (p and p.valid and pexclude ~= p and not p.spectator and not p.exiting and not (p.pflags & PF_TIMEOVER)) then continue end
		out[i] = #p
		i = $+1
	end
	return out
end

local highest
local function getHighestPosition() -- Because the highest position isnt always the playercount due to position ties
	highest = 0
	for p in players.iterate do
		if not (p and p.valid and not p.spectator and not p.exiting and not (p.pflags & PF_TIMEOVER)) then continue end
		highest = max($, p.kartstuff[k_position])
	end
	return highest
end

local last
local function viewLast(p, ...)
	--print("executed viewLast")
	last = getHighestPosition()
	if last == 0 then return end
	COM_BufInsertText(p, "view #"..last)
end

COM_AddCommand("viewlast", viewLast, false)

local picked
local idTable, i
local function viewRandom(p, ...)
	if p ~= consoleplayer then return end -- we don't need any other clients continuing past here
	--print("executed viewRandom")
	idTable = getActivePlayerIdArray(displayplayers[0])
	if #idTable == 0 then return end -- only one possible choice and youre already viewing them

	picked = Rescale(au_randomnum, 1, FRACUNIT, FRACUNIT, FRACUNIT*#idTable+FRACUNIT-1)>>FRACBITS -- the -1 ensures that the last number gets all of the numbers above it for randomness to count, the bitshift floors

	--print("tablelength "..#idTable.." picked "..picked)
	COM_BufInsertText(p, "view "..idTable[picked])
end

COM_AddCommand("viewrandom", viewRandom, false)

COM_AddCommand("viewname", function(p, name, ...)
	--print("executed viewName")
	for player in players.iterate do
		if string.find(string.lower(player.name), string.lower(name)) then
			COM_BufInsertText(p, "view "..#player)
			return
		end
	end
	print("Couldn't find a player with "..name.." in their name")
end, false)

-- This depends on consoleplayer.lua
--local dspec, sspec, dto
local dp
local checksink = 4 -- were only gonna check every 3 tics to try and reduce any performance impact this might have
addHook("ThinkFrame", function()
	
	au_randomnum = P_RandomRange(1, FRACUNIT) -- always draw to keep sync
	
	if not (consoleplayer and consoleplayer.valid and consoleplayer.spectator) then
		return 
	else
		dp = displayplayers[0]
		if dp ~= consoleplayer and (not dp.valid or dp.spectator or (dp.pflags & PF_TIMEOVER)) then viewLast(consoleplayer) end -- Elim/HPmod autoswitch
		if leveltime == 3 and consoleplayer.spectator then viewRandom(consoleplayer) end -- autospectate at start of race
		if not (checksink%3) and cv_sinkspectate.value then 
			for p in players.iterate do if p.kartstuff[k_itemtype] == KITEM_KITCHENSINK then COM_BufInsertText(consoleplayer, "view "..#p) end end -- behold my poorly formatted code and weep!
		end
		checksink = $+1
	end
end)
